<?php
/*
=====================================================
sama portal iran
=====================================================
*/
@session_start();
@error_reporting(7);
@ini_set('display_errors', true);
@ini_set('html_errors', false);

define('DATALIFEENGINE', true);
define('ROOT_DIR', '../..');
define('ENGINE_DIR', '..');

include ENGINE_DIR.'/data/config.php';

if ($config['http_home_url'] == "") {

	$config['http_home_url'] = explode("sys/ajax/antivirus.php", $_SERVER['PHP_SELF']);
	$config['http_home_url'] = reset($config['http_home_url']);
	$config['http_home_url'] = "http://".$_SERVER['HTTP_HOST'].$config['http_home_url'];

}

require_once ENGINE_DIR.'/classes/mysql.php';
require_once ENGINE_DIR.'/data/dbconfig.php';
require_once ENGINE_DIR.'/inc/include/functions.inc.php';

$selected_language = $config['langs'];

if (isset( $_COOKIE['selected_language'] )) { 

	$_COOKIE['selected_language'] = trim(totranslit( $_COOKIE['selected_language'], false, false ));

	if ($_COOKIE['selected_language'] != "" AND @is_dir ( ROOT_DIR . '/sys/lan/' . $_COOKIE['selected_language'] )) {
		$selected_language = $_COOKIE['selected_language'];
	}

}

require_once ROOT_DIR.'/sys/lan/'.$selected_language.'/adminpanel.lng';

$config['charset'] = ($lang['charset'] != '') ? $lang['charset'] : $config['charset'];

require_once ENGINE_DIR.'/modules/sitelogin.php';

if(($member_id['user_group'] != 1)) {die ("error");}

class antivirus
{
	var $bad_files       = array();
	var $snap_files      = array();
	var $track_files      = array();
	var $snap      		 = false;
	var $checked_folders = array();
	var $dir_split       = '/';

	var $cache_files       = array(
	"./sys/cache/system/usergroup.php",
	"./sys/cache/system/category.php",
	"./sys/cache/system/vote.php",
	"./sys/cache/system/banners.php",
	"./sys/cache/system/banned.php",
	"./sys/cache/system/cron.php",
	"./sys/cache/system/informers.php",
	"./sys/data/config.php",
	"./sys/data/videoconfig.php",
	"./sys/data/wordfilter.db.php",
	);

	var $good_files       = array(
	"./sys/ajax/vote.php",
	"./sys/ajax/find_relates.php",
	"./sys/ajax/calendar.php",
	"./sys/ajax/editcomments.php",
	"./sys/ajax/editnews.php",
	"./sys/ajax/favorites.php",
	"./sys/ajax/newsletter.php",
	"./sys/ajax/rating.php",
	"./sys/ajax/registration.php",
	"./sys/ajax/addcomments.php",
	"./sys/ajax/antivirus.php",
	"./sys/ajax/updates.php",
	"./sys/ajax/clean.php",
	"./sys/ajax/pages.php",
	"./sys/ajax/poll.php",
	"./sys/ajax/rangsite.php",
	"./sys/ajax/rss.php",
	"./sys/ajax/keywords.php",
	"./sys/ajax/pm.php",
	"./sys/ajax/bbcode.php",
	"./sys/ajax/upload.php",
	"./sys/ajax/typograf.php",
	"./sys/cache/system/usergroup.php",
	"./sys/cache/system/category.php",
	"./sys/cache/system/vote.php",
	"./sys/cache/system/banners.php",
	"./sys/cache/system/banned.php",
	"./sys/cache/system/cron.php",
	"./sys/cache/system/informers.php",
	"./sys/data/config.php",
	"./sys/data/videoconfig.php",
	"./sys/data/dbconfig.php",
	"./sys/data/wordfilter.db.php",
	"./sys/skins/default.skin.php",
	"./sys/skins/installation.skin.php",
	"./sys/editor/fullnews.php",
	"./sys/editor/fullsite.php",
	"./sys/editor/newsletter.php",
	"./sys/editor/shortnews.php",
	"./sys/editor/shortsite.php",
	"./sys/editor/comments.php",
	"./sys/editor/jscripts/tiny_mce/tiny_mce_gzip.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/rpc.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/includes/general.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/config.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/classes/EnchantSpell.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/classes/utils/Logger.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/classes/utils/JSON.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/classes/SpellChecker.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/classes/PSpellShell.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/classes/PSpell.php",
	"./sys/editor/jscripts/tiny_mce/plugins/spellchecker/classes/GoogleSpell.php",
	"./sys/editor/jscripts/tiny_mce/plugins/emotions/emotions.php",
	"./sys/editor/jscripts/tiny_mce/plugins/typograf/handler.php",
	"./sys/editor/jscripts/tiny_mce/plugins/typograf/typographus.php",
	"./sys/editor/static.php",
	"./sys/classes/jdf.php",
	"./sys/classes/min/config.php",
	"./sys/classes/min/lib/JSMin.php",
	"./sys/classes/min/lib/Solar/Dir.php",
	"./sys/classes/min/lib/JSMinPlus.php",
	"./sys/classes/min/lib/Minify/Lines.php",
	"./sys/classes/min/lib/Minify/Cache/Memcache.php",
	"./sys/classes/min/lib/Minify/Cache/APC.php",
	"./sys/classes/min/lib/Minify/Cache/File.php",
	"./sys/classes/min/lib/Minify/Logger.php",
	"./sys/classes/min/lib/Minify/Packer.php",
	"./sys/classes/min/lib/Minify/CSS.php",
	"./sys/classes/min/lib/Minify/Controller/Groups.php",
	"./sys/classes/min/lib/Minify/Controller/Page.php",
	"./sys/classes/min/lib/Minify/Controller/Base.php",
	"./sys/classes/min/lib/Minify/Controller/MinApp.php",
	"./sys/classes/min/lib/Minify/Controller/Files.php",
	"./sys/classes/min/lib/Minify/Controller/Version1.php",
	"./sys/classes/min/lib/Minify/Build.php",
	"./sys/classes/min/lib/Minify/YUICompressor.php",
	"./sys/classes/min/lib/Minify/Source.php",
	"./sys/classes/min/lib/Minify/CommentPreserver.php",
	"./sys/classes/min/lib/Minify/ImportProcessor.php",
	"./sys/classes/min/lib/Minify/CSS/Compressor.php",
	"./sys/classes/min/lib/Minify/CSS/UriRewriter.php",
	"./sys/classes/min/lib/Minify/HTML.php",
	"./sys/classes/min/lib/FirePHP.php",
	"./sys/classes/min/lib/HTTP/Encoder.php",
	"./sys/classes/min/lib/HTTP/ConditionalGet.php",
	"./sys/classes/min/lib/Minify.php",
	"./sys/classes/min/builder/index.php",
	"./sys/classes/min/builder/ocCheck.php",
	"./sys/classes/min/index.php",
	"./sys/classes/min/utils.php",
	"./sys/classes/min/groupsConfig.php",
	"./sys/modules/vote.php",
	"./sys/modules/addnews.php",
	"./sys/modules/antibot.php",
	"./sys/modules/banned.php",
	"./sys/modules/bbcode.php",
	"./sys/modules/calendar.php",
	"./sys/modules/comments.php",
	"./sys/modules/favorites.php",
	"./sys/modules/feedback.php",
	"./sys/modules/functions.php",
	"./sys/modules/siteinfo.php",
	"./sys/modules/obmen.php",
	"./sys/modules/online.php",
	"./sys/modules/3news.php",
	"./sys/modules/onl.functions.php",
	"./sys/modules/gzip.php",
	"./sys/modules/imagepreview.php",
	"./sys/modules/lastcomments.php",
	"./sys/modules/lostpassword.php",
	"./sys/modules/offline.php",
	"./sys/modules/pm.php",
	"./sys/modules/pm_alert.php",
	"./sys/modules/profile.php",
	"./sys/modules/register.php",
	"./sys/modules/search.php",
	"./sys/modules/show.custom.php",
	"./sys/modules/show.full.php",
	"./sys/modules/show.short.php",
	"./sys/modules/category_block.php",
	"./sys/modules/sitelogin.php",
	"./sys/modules/static.php",
	"./sys/modules/stats.php",
	"./sys/modules/topnews.php",
	"./sys/modules/addcomments.php",
	"./sys/modules/poll.php",
	"./sys/modules/cron.php",
	"./sys/modules/banners.php",
	"./sys/modules/rssinform.php",
	"./sys/modules/fullsearch.php",
	"./sys/modules/deletenews.php",
	"./sys/modules/tagscloud.php",
	"./sys/api/api.class.php",
	"./sys/inc/iptools.php",
	"./sys/classes/mysql.class.php",
	"./sys/classes/mysqli.class.php",
	"./sys/classes/mail.class.php",
	"./sys/inc/mass_user_actions.php",
	"./sys/inc/addvote.php",
	"./sys/inc/blockip.php",
	"./sys/inc/categories.php",
	"./sys/inc/dboption.php",
	"./sys/inc/dumper.php",
	"./sys/inc/editnews.php",
	"./sys/inc/editusers.php",
	"./sys/inc/editvote.php",
	"./sys/inc/email.php",
	"./sys/inc/files.php",
	"./sys/inc/include/functions.inc.php",
	"./sys/inc/help.php",
	"./sys/inc/obmen.php",
	"./sys/inc/include/inserttag.php",
	"./sys/inc/main.php",
	"./sys/inc/videoconfig.php",
	"./sys/classes/thumb.class.php",
	"./sys/classes/comments.class.php",
	"./sys/inc/massactions.php",
	"./sys/classes/mysql.php",
	"./sys/inc/newsletter.php",
	"./sys/inc/options.php",
	"./sys/classes/parse.class.php",
	"./sys/inc/preview.php",
	"./sys/inc/static.php",
	"./sys/classes/templates.class.php",
	"./sys/inc/templates.php",
	"./sys/inc/userfields.php",
	"./sys/inc/usergroup.php",
	"./sys/inc/wordfilter.php",
	"./sys/inc/xfields.php",
	"./sys/inc/addnews.php",
	"./sys/inc/comments.php",
	"./sys/inc/banners.php",
	"./sys/inc/clean.php",
	"./sys/inc/rss.php",
	"./sys/inc/mass_static_actions.php",
	"./sys/inc/include/init.php",
	"./sys/classes/rss.class.php",
	"./sys/inc/search.php",
	"./sys/classes/download.class.php",
	"./sys/inc/cmoderation.php",
	"./sys/inc/rssinform.php",
	"./sys/classes/google.class.php",
	"./sys/inc/googlemap.php",
	"./sys/preview.php",
	"./sys/init.php",
	"./sys/opensearch.php",
	"./sys/engine.php",
	"./sys/images.php",
	"./sys/print.php",
	"./sys/rss.php",
	"./sys/download.php",
	"./sys/go.php",
	"./admin.php",
	"./index.php",
	"./autobackup.php",
	);

	function antivirus ()
	{
		if(@file_exists(ENGINE_DIR.'/data/snap.db')) {
  			$filecontents = file(ENGINE_DIR.'/data/snap.db');

	    foreach ($filecontents as $name => $value) {
    	  $filecontents[$name] = explode("|", trim($value));
    	    $this->track_files[$filecontents[$name][0]] = $filecontents[$name][1];
	    }
			$this->snap = true;

		}

	}
	
	function scan_files( $dir, $snap = false )
	{
		$this->checked_folders[] = $dir . $this->dir_split . $file;
	
		if ( $dh = @opendir( $dir ) )
		{
			while ( false !== ( $file = readdir($dh) ) )
			{
				if ( $file == '.' or $file == '..' or $file == '.svn' or $file == '.DS_store' )
				{
					continue;
				}
		
				if ( is_dir( $dir . $this->dir_split . $file ) )
				{

					if ($dir != ROOT_DIR)
					$this->scan_files( $dir . $this->dir_split . $file, $snap );
				}
				else
				{

					if ($this->snap OR $snap) $templates = "|tpl|js"; else $templates = "";

					if ( preg_match( "#.*\.(php|cgi|pl|perl|php3|php4|php5|php6".$templates.")#i", $file ) )
					{

					  $folder = str_replace("../..", ".",$dir);
					  $file_size = filesize($dir . $this->dir_split . $file);
					  $file_crc = strtoupper(dechex(crc32(file_get_contents($dir . $this->dir_split . $file))));
					  $file_date = jdate("Y/m/d H:i:s", filectime($dir . $this->dir_split . $file));

					  if ($snap) {

						$this->snap_files[] = array( 'file_path' => $folder . $this->dir_split . $file,
													 'file_crc' => $file_crc );


                      } else {

						if ($this->snap) {


							if ($this->track_files[$folder . $this->dir_split . $file] != $file_crc AND !in_array($folder . $this->dir_split . $file, $this->cache_files))
							$this->bad_files[] = array( 'file_path' => $folder . $this->dir_split . $file,
													'file_name' => $file,
													'file_date' => $file_date,
													'type' => 1,
													'file_size' => $file_size );

					    } else { 

						 if (!in_array($folder . $this->dir_split . $file, $this->good_files))
						 $this->bad_files[] = array( 'file_path' => $folder . $this->dir_split . $file,
													'file_name' => $file,
													'file_date' => $file_date,
													'type' => 0,
													'file_size' => $file_size ); 

						}

					  }
					}
				}
			}
		}
	}
}

$antivirus = new antivirus();

if ($_REQUEST['folder'] == "lokal"){

	$antivirus->scan_files( ROOT_DIR."/backup" );
	$antivirus->scan_files( ROOT_DIR."/sys" );
	$antivirus->scan_files( ROOT_DIR."/language" );
	$antivirus->scan_files( ROOT_DIR."/templates" );
	$antivirus->scan_files( ROOT_DIR."/uploads" );
	$antivirus->scan_files( ROOT_DIR."/upgrade" );
	$antivirus->scan_files( ROOT_DIR );

} elseif ($_REQUEST['folder'] == "snap") {

	$antivirus->scan_files( ROOT_DIR."/backup", true );
	$antivirus->scan_files( ROOT_DIR."/sys", true );
	$antivirus->scan_files( ROOT_DIR."/language", true );
	$antivirus->scan_files( ROOT_DIR."/templates", true );
	$antivirus->scan_files( ROOT_DIR."/uploads", true );
	$antivirus->scan_files( ROOT_DIR."/upgrade", true );
	$antivirus->scan_files( ROOT_DIR, true );

	$filecontents = "";

    foreach( $antivirus->snap_files as $idx => $data )
    {
		$filecontents .= $data['file_path']."|".$data['file_crc']."\r\n";
    }

    $filehandle = fopen(ENGINE_DIR.'/data/snap.db', "w+");
    fwrite($filehandle, $filecontents);
    fclose($filehandle);
	@chmod(ENGINE_DIR.'/data/snap.db', 0666);

} else {

	$antivirus->snap = false;
	$antivirus->scan_files( ROOT_DIR."/backup" );
	$antivirus->scan_files( ROOT_DIR."/sys" );
	$antivirus->scan_files( ROOT_DIR."/language" );
	$antivirus->scan_files( ROOT_DIR."/templates" );
	$antivirus->scan_files( ROOT_DIR."/uploads" );
	$antivirus->scan_files( ROOT_DIR."/upgrade" );
	$antivirus->scan_files( ROOT_DIR );

}

@header("Content-type: text/css; charset=".$config['charset']);

if (count($antivirus->bad_files)) {

echo <<<HTML
<table width="100%">
    <tr>
        <td colspan="2" style="padding:2px;">{$lang['anti_result']}</td>
    </tr>
    <tr>
        <td width="350" style="padding:2px;">{$lang['anti_file']}</td>
        <td width="100">{$lang['anti_size']}</td>
        <td width="150">{$lang['addnews_date']}</td>
        <td>&nbsp;</td>
    </tr>
HTML;

  foreach( $antivirus->bad_files as $idx => $data )
  { 

	if ($data['file_size'] < 50000) $color = "<font color=\"green\">";
	elseif ($data['file_size'] < 100000) $color = "<font color=\"blue\">";
	else $color = "<font color=\"red\">";

	$data['file_size'] = formatsize ($data['file_size']);
	if ($data['type']) $type = $lang['anti_modified']; else $type = $lang['anti_not'];

echo <<<HTML
    <tr>
        <td style="padding:2px;">{$color}{$data['file_path']}</font></td>
        <td>{$color}{$data['file_size']}</font></td>
        <td>{$color}{$data['file_date']}</font></td>
        <td>{$color}{$type}</font></td>
    </tr>
	<tr><td background="sys/skins/images/mline.gif" height=1 colspan=4></td></tr>
HTML;
  }
}
elseif ($_REQUEST['folder'] == "snap") {

echo <<<HTML
<table width="100%">
    <tr>
        <td style="padding:2px;" colspan="3">{$lang['anti_creates']}</td>
    </tr>
HTML;

}
else {

echo <<<HTML
<table width="100%">
    <tr>
        <td style="padding:2px;" colspan="3">{$lang['anti_notfound']}</td>
    </tr>
HTML;

}

echo <<<HTML
    <tr>
        <td style="padding:2px;" colspan=3><input onclick="check_files('global'); return false;" type="button" class="buttons" style="width:250px;" value="{$lang['anti_global']}"> <input onclick="check_files('snap'); return false;" type="button" class="buttons" style="width:150px;" value="{$lang['anti_snap']}"></td>
    </tr></table>
HTML;
?>